﻿// Adventure.as - Jim Bumgardner
//
// A boring adventure game, to illustrate state machines.
//

map = [ // STATE 0
	   ["You are in a room.  There is a doorway to the south.\r",
		  [["go south", 1]]  // this command puts us in state 1
		],

	    // STATE 1
	   ["You are in a treasure chamber.  There is a fabulous looking object on the floor, and a doorway to the north.",
		  [["go north", 0],  // this command puts us in state 0
		   ["pick up ", 2],  // these commands put us in state 2
		   ["get ", 2],
		   ["take ", 2]]
		],

	   // STATE 2 (end of game)
	   ["You have found the most fabulous object in the world!\r\rGame Over.\r",[]
	    ]];

MovieClip.prototype.addLetter = function()
{
	clearInterval(this.outputH);
	if (this.its_output.text.length < this.targ_output.length) {
		// add a letter
		var ch = this.targ_output.substr(this.its_output.text.length,1);
		this.its_output.text += ch;
		if (ch == "\r")
		  	ding_mc.gotoAndPlay(2);  	
		else
			thunk_mc.gotoAndPlay(2);
		this.outputH = setInterval(this,"addLetter", 25+random(100));
	}
	else {
		this.its_input.text = '';
		Selection.setFocus(this.its_input.text);
	}
}

MovieClip.prototype.addPrompt = function(prompt)
{
	this.targ_output += prompt;
	this.outputH = setInterval(this,"addLetter", 25+random(100));
}

MovieClip.prototype.setState = function(state)
{
	this.state = state;
	clearInterval(this.outputH);
	this.its_output.text = '';
	this.targ_output = '';
	this.addPrompt(map[state][0]);
}

game_mc.respondToInput = function()
{
  var input = this.its_input.text;
  for (var i = 0; i < map[this.state][1].length; ++i)
  {
	  var targpair = map[this.state][1][i];
	  // trace("Matching " + targpair[0] + " against " + input);
	  if (input.substr(0,targpair[0].length) == targpair[0]) {
		  this.setState(targpair[1]);
		  return;
	  }
  }
  this.addPrompt("\rI do not understand\r");
}


game_mc.onKeyUp = function()
{
  switch (Key.getCode()) {
  case Key.SHIFT:	shift_mc.gotoAndPlay(2);	break;
  }
}

game_mc.onKeyDown = function()
{
  switch (Key.getCode()) {
  case Key.SHIFT:	
  	shift_mc.gotoAndPlay(2);	
	break;
  case Key.BACKSPACE:
  case Key.DELETEKEY:
  case Key.LEFT:
  	thunk_mc.gotoAndPlay(2);  	
  	break;
  case Key.ENTER:
  case Key.DOWN:
  	this.respondToInput();
  	ding_mc.gotoAndPlay(2);  	
  	break;
  case Key.RIGHT:
  	shift_mc.gotoAndPlay(2);  	
  	break;
  case Key.UP:
  	shift_mc.gotoAndPlay(2);  	
  	break;
  default:			
  	thunk_mc.gotoAndPlay(2);
  break;
  }
}

Key.addListener(game_mc);
game_mc.its_output.text = '';
game_mc.its_input.text = '';
game_mc.setState(0);

fscommand("trapallkeys", "true");